<?php
namespace Teknisa\SUP\Modules\Cadastros\Controllers; 

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;

class OperadorProdComp extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    protected $dataSourceName = "operador_prodcomp";
    
    public function __construct($crudService, ParameterBag $parameterBag, $connection) {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->connection = $connection;
    }
    
    public function deleteProdComp($prod){
        $params = array();
        
        $params['CDPRODUTO']  = $prod['CDPRODUTO'];
        $params['CDOPERADOR'] = $prod['CDOPERADOR'];
        try {
            //Delete de "Produtos Comprados"        
            $sql = "DELETE FROM PRODCOMP WHERE CDPRODUTO = :CDPRODUTO AND CDOPERADOR = :CDOPERADOR";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function deleteLimProdAf($prod){
        $params = array();
        
        $params['CDPRODUTO']  = $prod['CDPRODUTO'];
        $params['CDOPERADOR'] = $prod['CDOPERADOR'];
        try{
            $sql = "DELETE FROM LIMPRODAF WHERE CDPRODUTO  = :CDPRODUTO AND CDOPERADOR = :CDOPERADOR";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function deleteLimNivelAf($prod){
        $params = array();
        
        $params['CDPRODUTO']  = $prod['CDPRODUTO'];
        $params['CDOPERADOR'] = $prod['CDOPERADOR'];
        try{
            $sql = "DELETE FROM LIMNIVELAF WHERE CDPRODUTO  = :CDPRODUTO AND CDOPERADOR = :CDOPERADOR";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function deleteProds(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
       
        foreach ($row as $prod) {
            $PRODCOMP   = self::getProdComp($prod);
            foreach ($PRODCOMP as $prodComp) {
                self::deleteProdComp($prodComp);
            }
            $LIMPRODAF  = self::getLimProdAf($prod);
            foreach ($LIMPRODAF as $limProdAf) {
                self::deleteLimProdAf($limProdAf);
            }
            $LIMNIVELAF = self::getLimNivelAf($prod);
            foreach ($LIMNIVELAF as $limNivelAf) {
                self::deleteLimNivelAf($limNivelAf);
            }
        } 
    }
    
    public function getProdComp($prod){
        $params = array();
        
        $params['CDARVPROD']  = $prod['CDARVPROD'];
        $params['CDOPERADOR'] = $prod['CDOPERADOR'];
        try {
            $sql = "SELECT DISTINCT PC.CDPRODUTO, PC.CDOPERADOR, P.CDARVPROD FROM PRODUTO P JOIN PRODCOMP PC ON P.CDPRODUTO = PC.CDPRODUTO WHERE PC.CDOPERADOR =:CDOPERADOR AND P.CDARVPROD LIKE CONCAT(:CDARVPROD, '%')";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function getLimProdAf($prod){
        $params = array();
        
        $params['CDARVPROD']  = $prod['CDARVPROD'];
        $params['CDOPERADOR'] = $prod['CDOPERADOR'];
        try {
            $sql = "SELECT DISTINCT LIMPRODAF.CDPRODUTO, LIMPRODAF.CDOPERADOR FROM PRODUTO, LIMPRODAF WHERE LIMPRODAF.CDOPERADOR = :CDOPERADOR AND PRODUTO.CDARVPROD LIKE CONCAT(:CDARVPROD, '%')";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function getLimNivelAf($prod){
        $params = array();
        
        $params['CDARVPROD']  = $prod['CDARVPROD'];
        $params['CDOPERADOR'] = $prod['CDOPERADOR'];
        try {
            $sql = "SELECT DISTINCT LIMNIVELAF.CDPRODUTO, LIMNIVELAF.CDOPERADOR FROM PRODUTO, LIMNIVELAF WHERE LIMNIVELAF.CDOPERADOR = :CDOPERADOR AND PRODUTO.CDARVPROD LIKE CONCAT(:CDARVPROD, '%')";
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
        } catch (Exception $e){
            throw $e;
        }
    }
}