<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\AnaliseCotacoes\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use \Teknisa\GER\Utilities\Environment;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Response\Message;

class Sup09100ConsultaDuplicacaoDeCotacoesController extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $qr2Strategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;

    public function __construct($reportService, $entityManager, $qr2Strategy, $newCode, $environment, $connection, $dataSourceManager) {
        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;
        $this->newCode             = $newCode;
        $this->environment         = $environment;
        $this->connection          = $connection;
        $this->dataSourceManager   = $dataSourceManager;
    }
    
    protected $reportMapping = array ();
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {   
        $row = $request->getRow();
        
        $row['TXDTINICD'] = $row['DTINICD'];
        $row['TXDTINIC'] = $row['DTINIC'];
        $row['TXDTFIMD'] = $row['DTFIMD'];
        $row['TXDTFIM'] = $row['DTFIM'];
        $row['PRODINI'] = $row['CDPRODINI'];
        $row['PRODFIM'] = $row['CDPRODFIM'];
        $row['CDPRODFIM'] = $row['CDPRODFIMCONC'];
        
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] =
                array (
                'strategy' => $row['STRATEGY'],
                'parameterMapping' =>
                array (
                    "FORNECEDOR"    => "L_CDFORNECED",
                    "OPERADOR"      => "L_CDOPERADOR",
                    "REGIAO"        => "L_CDREGIAO",
                    "DTINICD"       => "P_DTINICD",
                    "DTFIMD"        => "P_DTFIMD",
                    "DTINIC"        => "P_DTINIC", 
                    "DTFIM"         => "P_DTFIM",
                    "TXDTINICD"     => "P_TXDTINICD",
                    "TXDTFIMD"      => "P_TXDTFIMD",
                    "TXDTINIC"      => "P_TXDTINIC",
                    "TXDTFIM"       => "P_TXDTFIM",  
                    "CDPRODINI"     => "P_CDPRODINI",
                    "CDPRODFIM"     => "P_CDPRODFIM",
                    "PRODINI"       => "P_PRODINIC",
                    "PRODFIM"       => "P_PRODFIM",
                    "NMPRODUTOINI"  => "P_NMPRODINIC",
                    "NMPRODUTOFIM"  => "P_NMPRODFIM"
                    
                ),
        );
    }
    
    public function verificaComprador(DTO\Request\Row $request, DTO\Response $response) {
        
        $row = $request->getRow();
        $query = "SELECT OPERADOR.NMOPERADOR, OPERADOR.CDOPERADOR FROM COMPRADOR JOIN OPERADOR ON COMPRADOR.CDOPERADOR = OPERADOR.CDOPERADOR AND (COMPRADOR.CDOPERADOR = :P_CDOPERADOR)";
        $params = array(
            "P_CDOPERADOR" => $row['OPERADOR_LOGADO']
        );
        $stmt = $this->connection->prepare($query);
        $stmt->execute($params);
        $a = $stmt->fetchAll();
       
       
        $response->addDataSet(new DataSet('OPERADOR_LOGADO', $a));
    }
}