<?php

namespace Teknisa\SUP\Modules\Cotacao\Modules\ListaPreco\Services;

use Doctrine\ORM\EntityManager;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Sup01300VerificacaoListaPrecoService {
    
    protected $entityManager;
    protected $criptografia;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function updateItemcole($row) {
        $sql =
            "UPDATE
               ITEMCOLE
            SET
               ITEMCOLE.IDITMLISPREC = 'N'
            WHERE
              (ITEMCOLE.CDFILIAL  = :P_CDFILIAL) AND
               EXISTS(SELECT CDARVPROD
                      FROM PRODUTO
                      WHERE PRODUTO.CDPRODUTO = ITEMCOLE.CDPRODUTO AND
                            PRODUTO.CDARVPROD BETWEEN :P_CDINI AND :P_CDFIN) AND
               ((INSTR(:P_CDREGIAO, ITEMCOLE.CDREGIAO) <> 0     ) OR
               (:P_GCDREGIAO = 'G'                            )) AND
            
               EXISTS
                 (SELECT
                    IDTIPCOLREG
                  FROM
                    COLETAPR
                  WHERE
                    COLETAPR.CDFILIAL    = ITEMCOLE.CDFILIAL AND
                    COLETAPR.NRCOLEPRECO = ITEMCOLE.NRCOLEPRECO) AND
            
               EXISTS
                 (SELECT
                     PRODCOMP.CDOPERADOR
                  FROM
                     PRODUTO,
                     PRODUTO PR,
                     PRODCOMP
                  WHERE
                    ((INSTR(:P_CDOPERADOR, PRODCOMP.CDOPERADOR) <> 0    ) OR
                     (:P_TCDOPERADOR = 'T'                              )) AND
                     (ITEMCOLE.CDPRODUTO = PRODUTO.CDPRODUTO) AND
                     (PR.CDPRODUTO = PRODCOMP.CDPRODUTO) AND
                     (PRODUTO.CDARVPROD LIKE PR.CDARVPROD || '%'
                      OR PRODUTO.CDPRODESTO = PRODCOMP.CDPRODUTO)) AND
            
              (ITEMCOLE.IDITMLISPREC = 'S'                       ) AND
              (ITEMCOLE.DTFINVALITM < SYSDATE                    )";
        $params = array(
            "P_CDFILIAL"    => $row["CDFILIAL"],
            "P_CDINI"       => $row["CDARVPRODINI"]  ,
            "P_CDFIN"       => $row["CDARVPRODFIN"] = self::strPadRigthProd($row['CDARVPRODFIN']),
            "P_CDREGIAO"    => $row["CDREGIAO"],
            "P_GCDREGIAO"   => $row["GCDREGIAO"],
            "P_CDOPERADOR"  => $row["CDOPERADOR"],
            "P_TCDOPERADOR" => $row["TCDOPERADOR"]
        );
        $dataSet = $this->entityManager->getConnection()->executeUpdate($sql, $params);
        return $dataSet;
    }
    private function strPadRigthProd($value){
	    return str_pad($value, 20, 'Z', STR_PAD_RIGHT);
	}
    
    public function getCdFilial($cdfilial) {
        $query = $this->entityManager->getConnection()->prepare(
            "SELECT DISTINCT
                NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL)  AS CDFILIAL
              FROM
                FILIAL FIL,
                FILIAL
              WHERE
                (FILIAL.CDFILIAL = :P_CDFILIAL) AND
                NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) = FIL.CDFILIAL"
        );
        $query->execute(
            array(
                "P_CDFILIAL" => $cdfilial
            )
        );
        $cdfilial2 = $query->fetchAll()[0]["CDFILIAL"];
        return $cdfilial2;
    }
}