<?php
namespace Teknisa\SUP\Modules\Cotacao\Modules\Pedido\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Sup02300PedidoColetaGeralController extends \Zeedhi\Framework\Controller\Report
{
    protected $qr2Strategy;
    protected $stNomeRel;
    protected $stExtensao;
    protected $supUtilities;
    protected $connection;
    
    public  function __construct($reportService, $qr2Strategy, $supUtilities, $connection)
    {
        parent::__construct($reportService);
        $this->qr2Strategy   =   $qr2Strategy;
        $this->supUtilities  =   $supUtilities;
        $this->connection   =   $connection;
    }
    
    protected $reportMapping = array(
        'SUP02300' => array(
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                "P_CDFILIAL"   => "P_CDFILIAL",
                "L_CDFORNECED" => "L_CDFORNECED",
                "L_CDMENSAGEM" => "L_CDMENSAGEM",
                "P_CDINI"      => "P_CDINI",
                "P_CDFIN"      => "P_CDFIN"
            )
        ),
        
        'SUP02301' => array(
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                "P_CDFILIAL"   => "P_CDFILIAL",
                "L_CDFORNECED" => "L_CDFORNECED",
                "L_CDMENSAGEM" => "L_CDMENSAGEM",
                "P_CDINI"      => "P_CDINI",
                "P_CDFIN"      => "P_CDFIN"
            )
        )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {   
        $row = $request->getRow();
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
    }
}


